Description

The RESTController is inherited from the ActionController. Therefore the ArgumentHandling should work as intended.

The problem is due to the following code of the RESTController class.

public function processRequest(\F3\FLOW3\MVC\RequestInterface $request, \F3\FLOW3\MVC\ResponseInterface
$response) {
    $this->arguments->addNewArgument('id', 'UUID', FALSE);
    parent::processRequest($request, $response);
}

Adding an argument in this code portion results in an shift of all arguments of a called method. The value for the 1st argument is now
shifted to the second argument.

If addNewArgument is removed from that code it works as intended.

A possible solution would be to move that line into the initializeAction method. The argument is then added to the end of the argument
array and not to the beginning.

But actually it also shouldn't be passed to the method if it is not required or specified by the method.

Associated revisions
Revision e4fe5388 - 2009-09-28 11:45 - Karsten Dambekalns

[!!!][+BUGFIX] FLOW3 (MVC): The RESTController no longer defines the $id argument for methods, this fixes #4013. You must declare the $id
argument properly in your controller actions from now on!

History
#1 - 2009-07-28 11:57 - Robert Lemke
- Priority changed from Must have to -- undefined --
- Target version deleted (1.0 alpha 3)

#2 - 2009-07-28 17:00 - Karsten Dambekalns
- Subject changed from Arguement Handling in RESTController doesn't work correctly to Argument handling in RESTController doesn't work correctly

#3 - 2009-09-23 16:57 - Karsten Dambekalns
- Status changed from New to Accepted
- Assigned To set to Karsten Dambekalns
- Priority changed from -- undefined -- to Should have
- Target version set to 1.0 alpha 5

#4 - 2009-09-28 10:54 - Karsten Dambekalns

I propose to drop that we simply drop processRequest() from the RESTController. The $id argument should be specified in the action method's
signature as usual, the RESTController would do it's only magic in resolveActionMethodName() then. This solves the problem with argument shifting (I
stumbled across this, too) and gives back control over the use of the argument to the developer.

#5 - 2009-09-28 12:00 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset r3225.
